import com.ibm.aglet.*;
import com.ibm.aglet.event.*;
import java.net.*;
import java.io.*;
import java.net.URL;
import java.security.Security;
import java.security.*;
import java.math.BigInteger;
import java.math.*;
import java.util.*;

/**
 * This application does the encryption, publishing of weights and dispatching of the aglets to the
 * evaluators in the Multi-agent Dynamic Programming Application. Our Application here finds the
 * length of the longest path in a one-dimensional directed graph.
 */
public class DynaProEncryptionAgletApp extends Aglet {

	/** The length of the array which is chosen to be large enough to represent the
	 *  length of the longest path. Not a variable. So, with this program the maximum length of the
	 *  longest path cannot exceed 6.  So, the length of each link, that is the w values should be
	 *  chosen accordingly.  Else, we need to change the array length to fit the maximum length.
	 */
	static BigInteger [][] encWeightArray = new BigInteger [6][2];
	static BigInteger [][] shiftedArray = new BigInteger [6][2];
	static BigInteger [][] randomizedArray = new BigInteger [6][2];
	static BigInteger [][] weightPlusConstantArray = new BigInteger [6][2];
	static BigInteger [][] secondEncWeightArray = new BigInteger [6][2];
	static BigInteger [][] thirdEncWeightArray = new BigInteger [6][2];
	static BigInteger [][] MaxWeightArray = new BigInteger [6][2];
	static BigInteger [][] Result = new BigInteger [6][2];
	/** p (modulo) is a very large prime number **/
	static BigInteger p = new BigInteger("23");

	/** z is the common public element. Not a variable **/
	static String z = "5";
	/** n is the length of the array which is large enough to represent the
	 * length of the longest path. Not a variable.
	 */
	 static int n = 6;



	public void run() {

		/** Variables needed to fill up encWeightArray.
		 *  The different r vlaues (1,7,13 and 9) are also used to identify the different arrays
		 *  that are used to fill the different encrypted weights in the function jayElGamel.
		 */

		/** Here w is the weight of the link (2,3). Variable.**/
		 int w = 1;
		/** r is the random number chosen for encryption. Variable.
		 * The subsequent r values should in increments of 6 which is the array length.
		 */

		 String r = "1";
		 /** The constant that is to be added to the encrypted weight **/
		 int f = 0;
		/** Fills up encWeightArray **/

		System.out.println("\n");
		System.out.println("Encrypting the weight of each link and printing the resulting array contents....");
		System.out.println("\n");
		jayElGamel(w,n,z,r,f);

		/** Variables needed to fill up the secondEncWeight Array
		 * Here w is the weight of the link (1,2)
		 */
		w = 1;
		r = "7";
		f = 0;
		/**Fills up secondEncWeight array **/
		jayElGamel(w,n,z,r,f);

		/** Variables needed to fill up the thirdEncWeight Array
		 * Here w is the weight of the link (0,1)
		 */
		w = 1;
		r = "13";
		f = 0;
		/**Fills up thirdEncWeight array **/
		jayElGamel(w,n,z,r,f);


		/** Variables needed to fill up the randomized Array for Evaluator Two **/
		 w = 0 ;
		 r = "9";
		 f = 1;
		/**Fills up randomized array **/
		jayElGamel(w,n,z,r,f);


		try {

	/** Creating an object to pass the arguments to the proxy (Evaluator 2) **/

			Object args2 = new Object[] {
				encWeightArray,
				secondEncWeightArray
			 };

			URL destination2 = new URL("atp://jaypanda-4:3000");
	/**
	 * The EvaluatorTwo aglet proxy2 is created and dispatched to the
	 * destination.
	 */

			AgletProxy  proxy2 = getAgletContext().createAglet(getCodeBase(), "EvaluatorTwo", args2);
			System.out.println("\n");
	 		System.out.println("Dispatching the proxy(Evaluator 2) to the destination (port 3000)");
	 		System.out.println("\n");
			proxy2 = proxy2.dispatch(destination2);
	/**
	 * Message is sent to the EvalutorTwo aglet proxy2 at the destination2 and the result
	 * is collected.
	 */
	 		System.out.println("\n");
	 		System.out.println("Sending message to the proxy(Evaluator 2) at the destination to get the results....");
	 		System.out.println("\n");
			Message myResult = new Message("result");
			Result = (BigInteger[][])proxy2.sendMessage(myResult);



	/**
	 * The collected result is  printed to the console
	 */
		 	String tableString = "";
		 	for(int i = 0; i < n; i++){
		 		for(int j = 0; j < Result[i].length; j++){
		 			tableString += Result[i][j]+ "  ";
		 		}
		 		tableString += "\n";
		 	}
		 	System.out.println("\n");
		 	System.out.println("ResultArray from Evaluator 2");
    	 	System.out.println(tableString);

			System.out.println("\n");System.out.println("Decrypting the result collected from Evaluator 2 and printing....");
	 		System.out.println("\n");
			decryptWeight(n);

	/** Variables needed to fill up encWeightArray **/

	/** Here w is the weight of the link (1,3). Variable.**/
     		 w = 3;
			 r = "19";
			 f = 0;
	/** Fills up encWeightArray **/
			jayElGamel(w,n,z,r,f);


	/** Creating an object to pass the arguments to the proxy (Evaluator 1) **/
			Object args1 = new Object[] {
			/** Here encWeightArray has been reused to store the weight of the link (1,3).**/
				encWeightArray,
				Result,
				thirdEncWeightArray

			};

			URL destination1 = new URL("atp://jaypanda-4:4000");



 	/**
	 * The EvaluatorOne aglet proxy1 is created and dispatched to the
	 * destination1.
	 */

			AgletProxy  proxy1 = getAgletContext().createAglet(getCodeBase(), "EvaluatorOne", args1);
			System.out.println("\n");
	 		System.out.println("Dispatching the proxy(Evaluator 1) to the destination (port4000)");
	 		System.out.println("\n");
			proxy1 = proxy1.dispatch(destination1);
	/**
	 * Message is sent to the EvalutorOne aglet proxy at the destination1 and the result
	 * is collected.
	 */
	 		System.out.println("\n");
	 		System.out.println("Sending message to the proxy(Evaluator 1) at the destination to get the results....");
	 		System.out.println("\n");
			Message myResult1 = new Message("result");
			Result = (BigInteger[][])proxy1.sendMessage(myResult1);

	/**
	 * The collected result is  printed to the console
	 */
			tableString = "";
			for(int i = 0; i < n; i++){
				 for(int j = 0; j < Result[i].length; j++){
				 	tableString += Result[i][j]+ "  ";
				 }
				 tableString += "\n";
			}
			System.out.println("\n");
			System.out.println("ResultArray from Evaluator 1");
			System.out.println(tableString);

			System.out.println("Decrypting the result collected from Evaluator 1(final result) and printing....");
	 		System.out.println("\n");
			decryptWeight(n);

	/** The EvaluatorTwo aglet proxy2 is retracted from the destination2 and disposed
 	 */
		    proxy2 = getAgletContext().retractAglet(destination2,proxy2.getAgletID());
			proxy2.dispose();


	/** The EvaluatorOne aglet proxy1 is retracted from the destination1 and disposed
	 */
		    proxy1 = getAgletContext().retractAglet(destination1,proxy1.getAgletID());
			proxy1.dispose();

		}catch(MalformedURLException e) {

		}catch(Exception e) {

		}finally {

		}
	}// End of run()


	/**
	 * jayElGamel is the function that encrypts the weights using ElGamal Encryption Algorithm
	 */

	private void jayElGamel( int ww,int nn, String zz,String rr, int ff){

			final BigInteger ONE = new BigInteger("1");

			/** g is the base number **/
			BigInteger g = new BigInteger("5");
			/** x is the secret key. Not a variable. **/
			BigInteger x = new BigInteger("2");

			/** msg is the number to be encrypted **/
			BigInteger msg;
			/** r is the random number chosen for encryption**/
			BigInteger r = new BigInteger(rr);;

			int w23 = 0, w12 = 0, w01 = 0, w13 = 0;
			if(rr == "1"){
				w23 = ww;
			}
			else if(rr == "7"){
				w12 = ww;
			}
			else if(rr == "13"){
				w01 = ww;
			}
			else{
				w13 = ww;
			}

			for(int i = 0; i < nn; i++){

				if(ww > 0 && ff == 0 ){
					msg = new BigInteger(zz);
				}else if( ww == 0 && ff > 0 ){
					msg = new BigInteger(zz);
				}else {
					msg = new BigInteger("1");
				}


				/** y is the public key **/
				BigInteger y = new BigInteger("0");
				/** y1 is the first part of the encrypted value **/
				BigInteger y1 = new BigInteger("0");
				/** y2 is the second part of the encrypted value **/
				BigInteger y2 = new BigInteger("0");
				/** temporary variables: temp,t2 and t1 **/
				BigInteger temp = new BigInteger("0");
				BigInteger t2 = new BigInteger("0");
				int t1 = 0;

				y = g.modPow(x,p);

				//System.out.println("Y is "+y);

				y1 = g.modPow(r,p);
				if(rr == "1"){
					encWeightArray[i][0] = y1;
				}else if(rr =="7"){
					secondEncWeightArray[i][0] = y1;
				}else if(rr == "13"){
					thirdEncWeightArray[i][0] = y1;
				}else if(rr == "19"){
					encWeightArray[i][0] = y1;
				}else {
					randomizedArray[i][0] = y1;
				}


				//System.out.println("y1 is "+y1);
				t1 = r.intValue();
				y2 = (msg.multiply(y.pow(t1))).mod(p);
				//System.out.println("msg is "+msg);

				if(rr == "1"){
					encWeightArray[i][1] = y2;
				}else if(rr =="7"){
					secondEncWeightArray[i][1] = y2;
				}else if(rr == "13"){
					thirdEncWeightArray[i][1] = y2;
				}else if(rr == "19"){
					encWeightArray[i][1] = y1;
				}else {
					randomizedArray[i][1] = y2;
				}

				//System.out.println("y2 is "+y2);
				t1 = x.intValue();
				y1 = y1.pow(t1);
				temp = y1.modInverse(p);
				msg = y2.multiply(temp);
				//System.out.println("Message is "+msg);
				if(rr == "1" || rr == "7" || rr == "13" || rr == "19"){
					ww--;
				} else if(rr == "9"){
					ff--;
				}else{
				}
				//System.out.println("r is "+r);
				r = r.add(ONE);

			}// End of for loop in jayElGamel function

	/**
	 * Printing the Encrypted weight arrays to the console
	 */
			String tableString = "";
			if(rr == "1"){
				for(int i = 0; i < nn; i++){
					for(int j = 0; j < encWeightArray[i].length; j++){
						tableString += encWeightArray[i][j]+ "  ";
					}
					tableString += "\n";
				}
				System.out.println("Weight of the link (2, 3)");
				System.out.println("UnEncrypted weight = " +w23);
				System.out.println(" Value of r = "+rr);
				System.out.println("Encrypted weight = ");
				System.out.println(tableString);
		    }

		    tableString = "";
		    if(rr == "7"){
		    	for(int i = 0; i < nn; i++){
					for(int j = 0; j < secondEncWeightArray[i].length; j++){
						tableString += secondEncWeightArray[i][j]+ "  ";
					}
					tableString += "\n";
				}
				System.out.println("Weight of the link (1, 2)");
				System.out.println("UnEncrypted weight = " +w12);
				System.out.println(" Value of r = "+rr);
				System.out.println("Encrypted weight = ");
				System.out.println(tableString);
		    }

			tableString = "";
			if(rr == "13"){
				for(int i = 0; i < nn; i++){
					for(int j = 0; j < thirdEncWeightArray[i].length; j++){
						tableString += thirdEncWeightArray[i][j]+ "  ";
					}
				tableString += "\n";
				}
				System.out.println("Weight of the link (0, 1)");
				System.out.println("UnEncrypted weight = " +w01);
				System.out.println(" Value of r = "+rr);
				System.out.println("Encrypted weight = ");
				System.out.println(tableString);
			 }
			tableString = "";
			if(rr == "19"){
				for(int i = 0; i < nn; i++){
					for(int j = 0; j < encWeightArray[i].length; j++){
						tableString += encWeightArray[i][j]+ "  ";
					}
				tableString += "\n";
				}
				System.out.println("Weight of the link (1, 3)");
				System.out.println("UnEncrypted weight = " +w13);
				System.out.println(" Value of r = "+rr);
				System.out.println("Encrypted weight = ");
				System.out.println(tableString);
			 }
	}//End of function jayElGamel

	/**
	 * decryptweight is the function that decrypts the weights using ElGamal Decryption Algorithm
	 */
	private  void decryptWeight(int nn){
	 	int optimalValuef2plusEncWeight = 0;
		BigInteger msg;
	 	BigInteger y1;
	 	BigInteger y2;
	 	BigInteger temp = new BigInteger("0");
	 	BigInteger x = new BigInteger("2");
	 	BigInteger p = new BigInteger("23");
	 	BigInteger FIVE = new BigInteger("5");
		int t1 = 0;

	 	t1 = x.intValue();
	 	//System.out.println("Before Entering the last loop");
	 	for(int i = nn-1; i >= 0; i--){
	 		//System.out.println("Entering the last loop");
	 		y1 = Result[i][0];
	 		y2 = Result[i][1];
	 		y1 = y1.pow(t1);
	 		temp = y1.modInverse(p);
	 		msg = (y2.multiply(temp)).mod(p);
	 		if(msg.equals(FIVE)){
	 			optimalValuef2plusEncWeight = i+1;
	 			//System.out.println("optimalValuef2 + encWeight w(1,2) = "+optimalValuef2plusEncWeight);
	 			System.out.println("The length of the longest path so far = "+optimalValuef2plusEncWeight);
	 			System.out.println("\n");
	 			//System.out.println("i = "+i);
	 			break;
		 		}
		 	}
	 	//return optimalValuef2;
	}//End of function decryptWeight

}//End of class