import com.ibm.aglet.*;
import com.ibm.aglet.event.*;
import java.net.*;
import java.io.*;
import java.net.URL;
import java.security.Security;
import java.security.*;
import java.math.BigInteger;
import java.math.*;
import java.util.*;
/**
 * This aglet does the job of Evaluator 2. Decrypts the wight in the encWeightArray (weight of the
 * link (2, 3) )and adds that decrypted weight retOptimalValuef2 to the encrypted weight in the
 * secondEncWeightArray (weight of the link (1, 2) ). Both encWeightArray and secondEncWeightArray will be passed on
 * to this aglet from the weight publisher (DynaProEncryptionAgletApp). That is the agent brings them as its arguments. The result
 * stored in weightplusconstantarray will then be returned to the weight publisher via message passing.
 */

public class EvaluatorTwo extends Aglet {
	boolean retracted = false;
	BigInteger encryptedResult ;
	static BigInteger [][] encWeightArray = new BigInteger [6][2];
	static BigInteger [][] shiftedArray = new BigInteger [6][2];
	static BigInteger [][] randomizedArray = new BigInteger [6][2];
	static BigInteger [][] weightPlusConstantArray = new BigInteger [6][2];
	static BigInteger [][] secondEncWeightArray = new BigInteger [6][2];
	static BigInteger [][] MaxWeightArray = new BigInteger [6][2];
	/** p (modulo) is a very large prime number **/
	static BigInteger p = new BigInteger("23");
	/** n is the length of the array which is large enough to represent the
	* length of the longest path. Not a variable.
 	*/
	static int n = 6;
	/** z is the common public element. Not a variable **/
	static String z = "5";
	/** r is the random number chosen for encryption. Variable.**/
	String r = "0";

/** handles the transfer of the result to the aglet
 * that dispatched this aglet
 */
	public boolean handleMessage(Message msg){
		if(msg.sameKind("result")){
			System.out.println("\n");
			System.out.println("Returning the optimal value of node 2 + weight of the link (1,2)....");
			System.out.println("\n");
			msg.sendReply(weightPlusConstantArray);
			return true;
		} else
			return false;
		}
/**
 * onCreation is called when the aglet is created and the arguments(args) are
 * paased from the creator aglet.
 */
	public void onCreation(final Object  args) {
		//System.out.println("onCreation is called");

	addMobilityListener(
			new MobilityAdapter() {
				/**
				 * args values are assigned to Local variables
				 */
				 BigInteger [][] encWeightArray = (BigInteger [][])((Object[])args)[0];
				 BigInteger [][] secondEncWeightArray = (BigInteger[][])((Object[])args)[1];



			    /**
			     * This function is called both the times when the aglet arrives
			     * at the destination(retracted = false) as well as when it is retracted
			     * (retracted = true)back.
			     */
				public void onArrival(MobilityEvent e) {
					try {
						if(retracted) {
							//System.out.println(" Value of r = "+rr);System.out.println("The returned encryptedResult is "+encryptedResult);
				 		}else {
						   try{
							   /**/
							   System.out.println("\n");
							   System.out.println("Evaluator 2 arriving at the destination...");
							   System.out.println("\n");

							  /** Variables needed to fill up the randomized Array **/
							  int w = 0;
							  r = "9";
							  int f = 0;

							  /** Function that decrypts the encWeightArray (weight of the link (2,3))
							   *  which is also the optimal value of the node 2.
							   */
							  int retOptimalValuef2;
							  retOptimalValuef2 = decryptWeight(n);

							  /**Fills up randomized array in preparation for adding the optimal value of node 2 with
							   * secondEncWeightArray (weight of the link (1,2))
							   */
							  f =  retOptimalValuef2;
							  jayElGamel(w,n,z,r,f);

							  /** Function that fills the shifted array in preparation
							   * for adding f(2) (optimal value of link 2) with secondEncWeightArray
							   */
							  fillShiftedArray(f, n);

							  /** Function that fills the weightPlusConstant array **/
							  fillweightPlusConstantArray(f,n);

						/**/
						   }catch (Exception m){
						   }
	    	       	   }
					}catch (Exception me) {
						dispose();
					}

				}//End of onArrival

				public void onReverting(MobilityEvent e) {

					retracted = true;

				}//End of onReverting

				/***/
				/** The jayElGamel function here is used to only fill the randomized array**/
				private  void jayElGamel( int ww,int nn, String zz,String rr, int ff){
					final BigInteger ONE = new BigInteger("1");

					/** g is the base number **/
					BigInteger g = new BigInteger("5");
					/** x is the secret key. Not a variable. **/
					BigInteger x = new BigInteger("2");

					/** msg is the number to be encrypted **/
					BigInteger msg;
					/** r is the random number chosen for encryption**/
					BigInteger r = new BigInteger(rr);;
					for(int i = 0; i < nn; i++){
						if(ww > 0 && ff == 0 ){
					/** Message that is to be encrypted here is z**/
							msg = new BigInteger(zz);
						}else if( ww ==0 && ff > 0 ){//for randomized array's first f elements
							msg = new BigInteger(zz);
						}else {//for randomized array's next n-f elements
					/**Message that is to be encrypted here is 1**/
							msg = new BigInteger("1");
						}
						/** y is the public key **/
						BigInteger y = new BigInteger("0");
						/** y1 is the first part of the encrypted value **/
						BigInteger y1 = new BigInteger("0");
						/** y2 is the second part of the encrypted value **/
						BigInteger y2 = new BigInteger("0");
						/** temporary variables: temp,t2 and t1 **/
						BigInteger temp = new BigInteger("0");
						BigInteger t2 = new BigInteger("0");
						int t1 = 0;

						y = g.modPow(x,p);

						//System.out.println("Y is "+y);
						y1 = g.modPow(r,p);
						if(rr == "1"){
							encWeightArray[i][0] = y1;
						}else if(rr =="5"){
							secondEncWeightArray[i][0] = y1;
						}else {
							randomizedArray[i][0] = y1;
			 			}
						//System.out.println("y1 is "+y1);
						t1 = r.intValue();
						y2 = (msg.multiply(y.pow(t1))).mod(p);
						//System.out.println("msg is "+msg);

						if(rr == "1"){
							encWeightArray[i][1] = y2;
						}else if(rr =="5"){
							secondEncWeightArray[i][1] = y2;
						}else {
							randomizedArray[i][1] = y2;
						}

						//System.out.println("y2 is "+y2);
						t1 = x.intValue();
						y1 = y1.pow(t1);
						temp = y1.modInverse(p);
						msg = y2.multiply(temp);
						//System.out.println("Message is "+msg);
						if(rr == "1" || rr == "5"){
					   		ww--;
						} else if(rr == "9"){
							ff--;
						}else{
						}
						r = r.add(ONE);
						//System.out.println("r is "+r);
					}//End of the for loop

					String tableString = "";
					for(int i = 0; i < nn; i++){
						for(int j = 0; j < secondEncWeightArray[i].length; j++){
							tableString += secondEncWeightArray[i][j]+ "  ";
						}
						tableString += "\n";
					}
					//System.out.println("SecondEncWeightarray");
					System.out.println("\n");
					System.out.println("Encrypted weight of the link (1,2) received from the weight publisher");
					System.out.println(tableString);
				}//End of jayElGamel

				private  void fillShiftedArray(int f, int nn){
					int m = 0;
					/** randomized array( array of E(z)s ) is being transferred to the top of the shifted array.
					 * The total elements transferred equals the vlaue of f.
					 */
					for(int i = 0; i < f; i++){
						for(int j = 0; j < shiftedArray[i].length; j++){
							shiftedArray[i][j] = randomizedArray[i][j];
						}
					}
                    /** The rest of the shifted array is being filled with the elements from top of the
                     *  encrypted weight of the link (1,2). This is same as pushing down the contents of the
                     * secondEncWeightArray by f elements and the result is stored in shiftedArray.
                     */
					for(int i = f; i < nn; i++){
						//System.out.println("entering");
						//System.out.println("m is"+m);
						for(int j = 0; j < shiftedArray[i].length; j++){
							shiftedArray[i][j] = secondEncWeightArray[m][j];
						}
						m++;
				    }

					String tableString = "";
					for(int i = 0; i < nn; i++){
						for(int j = 0; j < shiftedArray[i].length; j++){
							tableString += shiftedArray[i][j]+ "  ";
						}
						tableString += "\n";
					}
					System.out.println("\n");
					System.out.println("optimal value of node 2 + weight of the link (1,2)");
					System.out.println("(Encrypted weight of the link (1,2) array elements shifted down by the optimal value of node 2)");
					System.out.println(tableString);

				}//End of fillShiftedArray

				private  void fillweightPlusConstantArray(int f, int nn){
					/** The first f elements of the randomized array ( array of E(z)s ) are being
                     *  transferred to the weightPlusConstant array.
                     */
					for(int i = 0; i < f; i++){
						for(int j = 0; j < weightPlusConstantArray[i].length; j++){
							weightPlusConstantArray[i][j] = randomizedArray[i][j];
						}

					}
					/** The rest of the  elements of the weightPlusConstantArray are filled with
					 * product of the bottom n-f elements of shifted array and randomized array's E(1)s.
                     */

					for(int i = f; i < nn; i++){
						for(int j = 0; j < weightPlusConstantArray[i].length; j++){
							weightPlusConstantArray[i][j] = (shiftedArray[i][j].multiply(randomizedArray[i][j])).mod(p);
						}

					}
					String tableString = "";
					for(int i = 0; i < nn; i++){
						for(int j = 0; j < weightPlusConstantArray[i].length; j++){
							tableString += weightPlusConstantArray[i][j]+ "  ";
						}
						tableString += "\n";
					}
					System.out.println("Optimal value of node 2 + weight of the link (1, 2) i.e.,the previous array after randomizing");
					System.out.println(tableString);

				}//End of fillWeightPlusConstatntArray


				private  void findMaxWeight(int f, int nn){
					for(int i = 0; i < nn; i++){
						for(int j = 0; j < MaxWeightArray[i].length; j++){
							MaxWeightArray[i][j] = (weightPlusConstantArray[i][j].multiply(secondEncWeightArray[i][j])).mod(p);
						}
					}

					String tableString = "";
					for(int i = 0; i < nn; i++){
						for(int j = 0; j < MaxWeightArray[i].length; j++){
							tableString += MaxWeightArray[i][j]+ "  ";
						}
						tableString += "\n";
					}
					//System.out.println("MaxWeightArray from Evaluator 2");
					//System.out.println(tableString);
				}//End of findMaxWeight

				/** Used here to find out the optimal value of the node 2 **/
				private  int decryptWeight(int nn){
					int optimalValuef2 = 0;
					BigInteger msg;
					BigInteger y1;
					BigInteger y2;
					BigInteger temp = new BigInteger("0");
					BigInteger x = new BigInteger("2");
					BigInteger p = new BigInteger("23");
					BigInteger FIVE = new BigInteger("5");
					int t1 = 0;

					t1 = x.intValue();

					String tableString = "";
					for(int i = 0; i < n; i++){
						for(int j = 0; j < encWeightArray[i].length; j++){
							tableString += encWeightArray[i][j]+ "  ";
						}
						tableString += "\n";
					}
					System.out.println("\n");
					System.out.println("Encrypted optimal value of node 2 received from the weight publisher");
					System.out.println(tableString);
					//System.out.println("Before Entering the last loop");
					for(int i = nn-1; i >= 0; i--){
						//System.out.println("Entering the last loop");
						y1 = encWeightArray[i][0];
						y2 = encWeightArray[i][1];
						y1 = y1.pow(t1);
						temp = y1.modInverse(p);
						msg = (y2.multiply(temp)).mod(p);
						/** Comparing the msg value here with value of z (which is 5).
						 * Any encrypted array has E(z) as the first w elements. Since we decrypt from
						 * the bottom of the array, wherever we get the decrypted value as z that array index
						 * value gives the actual weight. Since our array index (i) starts with the value zero
						 * we add one to it to get the actual weight.
						 */

						if(msg.equals(FIVE)){
							optimalValuef2 = i+1;
							System.out.println("\n");
							System.out.println("optimalValue of node 2 (after decrypted by this  Evaluator ) = "+optimalValuef2);
							//System.out.println("i = "+i);
							break;
						}
					}
					return optimalValuef2;
				}//End of decryptWeight
				/***/


			}//End of MobilityAdapter
		);//End of addMobilityListener
	}//End of OnCreation
}//End of class